#!/usr/bin/perl

sub radix_sort {
    my $tablica = shift;

    my $ze = $tablica;
    my $do;

    # Wszystkie dlugosci powinny byc rowne.
    for ( my $i = length $tablica->[ 0 ] - 1; $i >= 0; $i-- ) {
        # Nowy kosz.
        $do = [ ];
        foreach my $karta ( @$ze ) {
            # Stabilnosc jest kluczowa, wiec uzywamy push().
            push @{ $do->[ ord( substr $karta, $i ) ] }, $karta;
        }

        # Laczymy kosze.

        $ze = [ map { @{ $_ || [ ] } } @$do ];
    }

    # Teraz kopiujemy elementy do oryginalnej tablicy.

    @$tablica = @$ze;
}

@tablica = qw(smok plik plac Wilk skok dach dzik);
radix_sort(\@tablica);
print "@tablica\n";
